/**
 * MEDOR: Middleware Enabling Distributed Object Requests
 * 
 * Copyright (C) 2001-2004 France Telecom R&D
 * Contact: alexandre.lefebvre@rd.francetelecom.com
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Initial developers: M. Alia, S. Chassande-Barrioz, A. Lefebvre
 */
package org.objectweb.medor.expression.converter.api;

import org.objectweb.medor.expression.api.Expression;
import org.objectweb.medor.expression.api.ExpressionException;
import org.objectweb.jorm.mapper.rdb.adapter.api.RdbAdapter;

/**
 * Converts an expression to a relation where clause.
 * @author A. Lefebvre
 */
public interface Expression2WhereClause {
	/**
	 * Converts an expression to a relational where clause
	 * @param exp the Expression to be converted
	 * @param rdbAdapter the RdbAdapter which can be necessary to compute parts
	 * of the query which may depend from the relational database
	 * @return the SQL WHERE clause corresponding to the input Expression, as a
	 * String 
	 * @throws ExpressionException
	 */
	String convertExp2WhereClause(Expression exp, RdbAdapter rdbAdapter)
	throws ExpressionException;
}
