/**
 * MEDOR: Middleware Enabling Distributed Object Requests
 *
 * Copyright (C) 2001-2002 France Telecom R&D
 * Contact: alexandre.lefebvre@rd.francetelecom.com
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Initial developers: M. Alia, S. Chassande-Barrioz, A. Lefebvre
 */
package org.objectweb.medor.query.jorm;

import org.objectweb.medor.jorm.TestJormHelper;

import java.util.ArrayList;

/**
 * @author S.Chassande-Barrioz
 */
public abstract class TestJormPDHelper extends TestJormHelper {

    public TestJormPDHelper(String testName, String loggerName) {
        super(testName, loggerName);
    }

    public Example getExtentOfA() {
        ArrayList al = new ArrayList();
        al.add("org/objectweb/medor/query/jorm/A.pd");
        al.add("org/objectweb/medor/query/jorm/B.pd");
        return getExtent(al, "org.objectweb.medor.query.jorm.A");
    }
    public Example getRewritedA() {
        return getRewritten(getExtentOfA());
    }

    public Example getExtentOfB() {
        ArrayList al = new ArrayList();
        al.add("org/objectweb/medor/query/jorm/B.pd");
        al.add("org/objectweb/medor/query/jorm/C.pd");
        return getExtent(al, "org.objectweb.medor.query.jorm.B");
    }
    public Example getRewritedB() {
        return getRewritten(getExtentOfB());
    }

    public Example getExtentOfC() {
        ArrayList al = new ArrayList();
        al.add("org/objectweb/medor/query/jorm/C.pd");
        al.add("org/objectweb/medor/query/jorm/D.pd");
        return getExtent(al, "org.objectweb.medor.query.jorm.C", "object1", null);
    }
    public Example getExtentOfD() {
        ArrayList al = new ArrayList();
        al.add("org/objectweb/medor/query/jorm/D.pd");
        return getExtent(al, "org.objectweb.medor.query.jorm.D");
    }
    public Example getExtentOfD(String[] fn) {
        ArrayList al = new ArrayList();
        al.add("org/objectweb/medor/query/jorm/D.pd");
        return getExtent(al, "org.objectweb.medor.query.jorm.D", TestJormHelper.DEFAULT_PNAME_FIELD_NAME + 1, fn);
    }
    public Example getRewritedD() {
        return getRewritten(getExtentOfD());
    }


    public Example getExtentOfE() {
        ArrayList al = new ArrayList();
        al.add("org/objectweb/medor/query/jorm/E.pd");
        return getExtent(al, "org.objectweb.medor.query.jorm.E");
    }
    public Example getRewritedE() {
        return getRewritten(getExtentOfE());
    }

}
